<?php
/*
Mage Reviews
*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
?>
<?php
if (!defined('MAGECORE')) exit;
add_action('init', 'summon_mage_ratings');
add_action( 'comment_form_logged_in_after', 'mage_rating_fields' );
add_action( 'comment_form_after_fields', 'mage_rating_fields' );
add_action('comment_post', 'mage_add_comment_rating',9);
add_action('comment_post', 'mage_update_rating',9);
add_filter( 'preprocess_comment', 'mage_verify_comment_rating' );
add_action('edit_comment', 'mage_update_rating');	
add_action('comment_unapproved_to_approved', 'mage_update_rating');
add_action('comment_approved_to_unapproved', 'mage_update_rating');
add_action('comment_spam_to_approved', 'mage_update_rating');
add_action('comment_approved_to_spam', 'mage_update_rating');
add_action('comment_approved_to_trash', 'mage_update_rating');
add_action('comment_trash_to_approved', 'mage_update_rating');
add_filter( 'comment_text', 'mage_display_comment_rating');
add_action( 'add_meta_boxes_comment', 'custom_comment_meta_box' );
add_shortcode('reviews', 'mage_reviews_average');
add_action( 'edit_comment', 'extend_comment_edit_metafields' );
if (mage_get_option('display_average')) add_filter( 'the_content', 'add_review_average'); 
function mage_user_reviewed(){
	global $current_user,$post;
	$reviewed = false;
	$check = mage_count_reviews($post,$current_user->ID);
	if(check >= 1)$reviewed = true;
	return $reviewed;
}
function mage_count_reviews($post, $user_id=0){
	$args = array(
	//'author_email' => '',
	//'ID'           => '',
	//'karma'        => '',
	//'number'       => '',
	//'offset'       => '',
	//'orderby'      => '',
	//'order'        => 'DESC',
	//'parent'       => '',
	'post_ID'      => $post->ID,
	//'post_name'    => '',
	//'post_parent'  => '',
	//'post_status'  => '',
	//'post_type'    => '',
	'status'       => 'approve',
	//'type'         => '',
	//'search'       => '',
	//'count'        => false,
	'meta_key'     => 'rating',
	//'meta_value'   => '',
	//'meta_query'   => ''
);
if ($user_id != 0) $args['user_id']  = $user_id;

$c_query = new WP_Comment_Query;
$comments = $c_query->query( $args );
$count = 0;
if ( $comments ) foreach ($comments as $comment) $count++;
return $count;	
}
function mage_review_post_type($check){
	$post_type = get_post_type($check);
	if (!$post_type) return false;
	//$post_type = $check->post_type;
	$types = mage_get_option('post_type_ratings');
	if (is_array($types) && in_array($post_type,$types)) {
  		return true;
	}
	return false;
}
function add_review_average($content) {
	global $post;
	if (mage_review_post_type($post)) {
  		return mage_get_review_average() . $content;
	}
	return $content;
}
function mage_get_review_average() {
    return do_shortcode("[reviews]");
}
function mage_reviews_average( $atts, $content = null ){extract(shortcode_atts(array('status' => '','pre'=>'','wrap'=>'span','var'=>'review','one'=>'','zero'=>'','more'=>'','class'=>'','style'=>''), $atts));
	global $post;
	$count = is_object($post)? mage_count_reviews($post): 0;
	if ($count == 0){
		$content = empty($zero)? $var.'s': $zero;	
	} elseif ($count > 1) {
		$content = empty($more)? $var.'s': $more;	
	} else {
		$content = empty($one)? $var: $one;
	}
	$reviewCount = ' <div class="review-count">'.$pre.'<span itemprop="reviewCount">'.$count.'</span> '.$content.'</div>';
	$class=magex($class,'class="',' author-rating" ','class="author-rating" ');
	$style=magex($style,'style="','" ');
	$ave = $value = get_post_meta($post->ID, 'rating', true);
	$maximum = mage_get_option('rate_count',5);
	$divident = 100/$maximum;
	if(!empty($ave)) {
		$value = $value/$divident;
  		return '<div class="average-rating" itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating">
		<meta itemprop="ratingValue" content="'.$value.'"><div '.$class.$style.'><span style="width:'.$ave.'%;"></span></div>'.$reviewCount.'</div>';
	} else { 
		if (mage_get_option('display_average_empty')) return '<div '.$class.$style.' itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating"></div>'; 
	}
}
function custom_comment_meta_box() {
    add_meta_box( 'title', __( 'Comment Metadata - Extend Comment' ), 'comment_meta_boxes', 'comment', 'normal', 'high' );
}

function comment_meta_boxes ( $comment ) {
    $rating = get_comment_meta( $comment->comment_ID, 'rating', true );
	$count = mage_get_option('rate_count',5);
    wp_nonce_field( 'extend_comment_update', 'extend_comment_update', false );
    ?>
    <p>
        <label for="rating"><?php _e( 'Rating: ' ); ?></label>
			<span class="commentratingbox">
			<?php for( $i=1; $i <= $count; $i++ ) {
				echo '<span class="commentrating"><input type="radio" name="rating" id="rating" value="'. $i .'"';
				if ( $rating == $i ) echo ' checked="checked"';
				echo ' />'. $i .' </span>';
				}
			?>
			</span>
    </p>
    <?php
}
function extend_comment_edit_metafields( $comment_id ) {
    if( ! isset( $_POST['extend_comment_update'] ) || ! wp_verify_nonce( $_POST['extend_comment_update'], 'extend_comment_update' ) ) return;
	if ( ( isset( $_POST['rating'] ) ) && ( $_POST['rating'] != '') ):
	$rating = wp_filter_nohtml_kses($_POST['rating']);
	update_comment_meta( $comment_id, 'rating', $rating );
	else :
	delete_comment_meta( $comment_id, 'rating');
	endif;

}
function mage_display_comment_rating( $text ){
	global $post;
	if (mage_review_post_type($post)) {
		$count = mage_get_option('rate_count',5);
		if($rating = get_comment_meta (get_comment_ID(), 'rating', true )) {
			$rating = 100/$count*$rating;
			$commentrating = '<div class="author-rating"><span style="width:'.$rating.'%;"></span></div>';
			$text = $commentrating.$text;
			return $text;
		} else {
			return $text;
		}
	}
	return $text;
}
function summon_mage_ratings(){	
	add_action( 'wp_enqueue_scripts', 'add_mage_scripts');
	add_action('wp_enqueue_scripts','add_mage_styles',20);
	add_action('wp_enqueue_scripts', 'mage_rating_custom_icon', 21 );
}
function add_mage_scripts() {
	global $post;
	if (mage_review_post_type($post)) {
		wp_enqueue_script('mage-ratings', MAGESOURCE.'js/mage-ratings.js','','1.0',$in_footer = true);
	}
}
function add_mage_styles() {
	global $post;
	if (mage_review_post_type($post)) {
		wp_enqueue_style('mage-reviews', MAGESOURCE.'css/mage-ratings.css');
	}
}
function mage_rating_fields() {
	global $post;
	$settings = mage_get_option('rating_icon');
	$count = mage_get_option('rate_count',5);
	if (mage_review_post_type($post)) {
		$icon = is_array($settings)? $settings['src'] : $settings;
		$req = mage_get_option('optional_review',true);	
		echo '<p class="comment-form-rating"><label for="rating">'.__('Rating').( $req ? ' <span class="required">*</span>' : '' ).'</label>';
		echo '<span class="btn-group rating-options" data-toggle="buttons">';
		for( $i=$count; $i >= 1; $i-- ) echo '<label type="button" class="radio inline btn-rating btn" for="rating"><input class="required" type="radio" name="rating" id="rating" value="'. $i .'" /><img src="'.$icon.'" width="16" height="16" /></label>';
		echo '</span>';
		echo '</p>';
	}
}
function mage_rating_custom_icon() {
	global $post;
    $icon = mage_get_option( 'rating_icon');
	$count = mage_get_option('rate_count',5);
	if (mage_review_post_type($post)) {
		$width = $count*16;
		$icon_hover = mage_get_option( 'rating_icon_hover');
		$icon = isset($icon['src']) && !empty($icon['src'])? $icon['src'] : MAGEURL.'img/star-0.png';
		$icon_hover = isset($icon_hover['src']) && !empty($icon_hover['src'])? $icon_hover['src'] : MAGEURL.'img/star-1.png';
   		$custom_icon = '
        .author-rating {background-image: url('.$icon.');width: '.$width.'px;}
		.author-rating > span, .rating-options > .btn-rating:hover:before, .rating-options > .btn-rating.active:before, .rating-options > .btn-rating:hover ~ .btn-rating:before, .rating-options > .btn-rating.active ~ .btn-rating:before {background-image: url('.$icon_hover.');}';
    	wp_add_inline_style( 'mage-reviews', $custom_icon );
	}
}


function mage_update_rating($comment) {	
	if ( !is_object( $comment ) ){
        $comment = get_comment($comment);
    }
	$parent = $comment->comment_post_ID;
	if (mage_review_post_type($parent)) {
		$rating = get_comment_meta ($comment->comment_ID, 'rating', true );
		$count = mage_get_option('rate_count',5);
		if (!empty($rating)) {
    		if(is_email($comment->comment_author_email)) {		
				$rating =!empty($rating)? get_comment_meta ($comment->comment_ID, 'rating', true ):'';
				$comments = get_comments(array('post_id' => $parent, 'comment_approved'=>1));
		
				if (empty($comments)) {
					add_post_meta($parent, 'rating', $rating, true);			
				} else {		
					$i = $rating = 0;	    		
   					foreach($comments as $comment) {
						$rate = get_comment_meta ($comment->comment_ID, 'rating', true );
						if  (!empty($rate)) {
							$rating += $rate;
							$i++;
						}
					}
				$ave = $rating/$i;  
				$rating = 100/$count*$ave;
				update_post_meta($parent, 'rating', $rating);    	
		 		}
    		}
		}
	}
}
function mage_add_comment_rating($comment_id){
	$comment = get_comment($comment_id);
	$parent = $comment->comment_post_ID;
	if (mage_review_post_type($parent)) {
		if (isset($_POST['rating']) && !empty($_POST['rating'])){
			$rating = wp_filter_nohtml_kses($_POST['rating']);
 			add_comment_meta($comment_id, 'rating', $rating, true);
		}
	}
}
function mage_verify_comment_rating( $commentdata ) {
	$parent = $commentdata['comment_post_ID'];
	if (mage_review_post_type($parent)) {
		if (mage_get_option('optional_review',true)) if (!isset($_POST['rating']) || empty($_POST['rating'])) wp_die( __( 'Error: Please add your rating.'));  
		if (mage_get_option('strict_user_reviews')) if (mage_user_reviewed()) wp_die( __( 'Error: You have already submitted a rating here.'));    
	}
	return $commentdata;
}